package com.ruoyi.system.service.impl.saveOnTheLargeScreenPower;

import com.ruoyi.system.model.power.dao.PowerClassificationQueryDao;
import com.ruoyi.system.model.power.dto.PowerDisplayDto;

import java.math.BigDecimal;
import java.util.Collections;
import java.util.List;

/**
 * 2024/9/12
 */
public class TangShanKuang implements SaveOnTheLargeScreen{
    @Override
    public List<PowerDisplayDto> save(String mindId, List<PowerDisplayDto> powerDisplayDtoList, List<PowerClassificationQueryDao> dao) {
        powerDisplayDtoList = Collections.synchronizedList(powerDisplayDtoList);
        powerDisplayDtoList.parallelStream().forEach(v -> {
            String[] split = v.getClassificationName().split(",");
            v.setClassificationName(split[split.length - 1]);
            for (int i = 0; i < split.length; i++) {
                switch (i){
                    case 0:
                        v.setLevelOneClassification(split[i]);
                        break;
                    case 1:
                        v.setLevelTwoClassification(split[i]);
                        break;
                    case 2:
                        v.setLevelThreeClassification(split[i]);
                        break;
                }
            }
        });
        powerDisplayDtoList.stream().forEach(v -> {
            if (isNull(v.getElectricityTip()) && isNull(v.getPowerTip())) v.setElectricityPriceTip(new BigDecimal(v.getElectricityTip()).divide(new BigDecimal(v.getPowerTip()), BigDecimal.ROUND_CEILING) + "");
            if (isNull(v.getElectricityPeak()) && isNull(v.getPowerPeak())) v.setElectricityPricePeak(new BigDecimal(v.getElectricityPeak()).divide(new BigDecimal(v.getPowerPeak()), BigDecimal.ROUND_CEILING) + "");
            if (isNull(v.getElectricityValley()) && isNull(v.getPowerValley())) v.setElectricityPriceValley(new BigDecimal(v.getElectricityValley()).divide(new BigDecimal(v.getPowerValley()), BigDecimal.ROUND_CEILING) + "");
            if (isNull(v.getElectricityFlat()) && isNull(v.getPowerFlat())) v.setElectricityPriceFlat(new BigDecimal(v.getElectricityFlat()).divide(new BigDecimal(v.getPowerFlat()), BigDecimal.ROUND_CEILING) + "");
        });
        return powerDisplayDtoList;
    }

    private boolean isNull(String num){
        return num != null && !num.equals("") && Double.parseDouble(num) != 0;
    }
}
